#include <nds.h>
#include <stdio.h>
#include <math.h>
	#include "screenshot.h"

#define DISTANCE 4


typedef struct
{
	int sX;
	int sY;
	u8 map[20][20];
}map;


map carte;
int compteur = 0, Vbl_compteur = 0, FPS = 0;
int32 lookX = 0, lookY = 0, angle = 90;


int DrawGLScene();
void LoadWorld();
void Vbl_func()
{
	if(Vbl_compteur==60)
	{
		FPS=compteur;
		Vbl_compteur=0;
		compteur=0;
	}
	
	Vbl_compteur++;
}


int main()
{	
	// Turn on everything
	powerON(POWER_ALL);

	// Setup the Main screen for 3D 
	videoSetMode(MODE_0_3D);
	videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE);
	vramSetMainBanks(VRAM_A_TEXTURE, VRAM_B_LCD, VRAM_C_SUB_BG, VRAM_D_LCD);
	
	// IRQ basic setup
	irqInit();
		irqSet(IRQ_VBLANK, Vbl_func);
		irqEnable(IRQ_VBLANK);
	
	SUB_BG0_CR = BG_MAP_BASE(31);
	BG_PALETTE_SUB[255] = RGB15(31,31,31);
	consoleInitDefault((u16*)SCREEN_BASE_BLOCK_SUB(31), (u16*)CHAR_BASE_BLOCK_SUB(0), 16);

	// initialize the geometry engine
	glInit();
	
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_ANTIALIAS);
	
	// setup the rear plane
	glClearColor(16,16,31,31); // BG must be opaque for AA to work
	glClearPolyID(63); // BG must have a unique polygon ID for AA to work
	glClearDepth(0x7FFF);

	// Set our viewport to be the same size as the screen
	glViewport(0,0,255,191);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(70, 256.0 / 192.0, 0.1, 100);
	
	// Set the current matrix to be the model matrix
	glMatrixMode(GL_MODELVIEW);
	
	//ds specific, several attributes can be set here	
	glPolyFmt(POLY_ALPHA(31) | POLY_CULL_NONE | POLY_FORMAT_LIGHT0| POLY_FORMAT_LIGHT1| POLY_FORMAT_LIGHT2);
	
	LoadWorld();
	
	while (1) 
	{
		glColor3f(0.5, 0.5, 0.5);
		
		// draw the scene
		DrawGLScene();
		
		// flush to screen	
		glFlush(0);
		
		// wait for the screen to refresh
		swiWaitForVBlank();
			if(compteur == 0)
				iprintf("%d\n", FPS);
			compteur++;
		
		scanKeys();
		if(keysDown() & KEY_START)
			screenshot("shot.bmp");
		
		if(keysHeld() & KEY_UP || keysHeld() & KEY_X)
			lookY -= 512;
		if(keysHeld() & KEY_DOWN || keysHeld() & KEY_B)
			lookY += 512;
		if(keysHeld() & KEY_LEFT || keysHeld() & KEY_Y)
			lookX -= 512;
		if(keysHeld() & KEY_RIGHT || keysHeld() & KEY_A)
			lookX += 512;
		if(keysHeld() & KEY_L)
		{
			angle++;
			if(angle > 360)
				angle = 0;
		}
		if(keysHeld() & KEY_R)
		{
			angle--;
			if(angle < 0)
				angle = 360;
		}
	}
	
	return 0;
}

int DrawGLScene()											// Here's Where We Do All The Drawing
{
	u8 x, y;
	/*ds does this automagicaly*///glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear Screen And Depth Buffer
	glLoadIdentity();
	gluLookAtf32(	lookX + DISTANCE * floattof32((float)cos(angle*M_PI/180)), inttof32(10), lookY + DISTANCE * floattof32((float)sin(angle*M_PI/180)), //position
					lookX, inttof32(0), lookY, //objectif
					inttof32(0), inttof32(1), inttof32(0)); //verticale
	//glTranslatef(-1, 0, 0);
	
	
	for(y = 0; y < carte.sY; y++)
	{
		for(x = 0; x < carte.sX; x++)
		{
			glBegin(GL_QUADS);
				glColor3f(1, 0, 0);		glVertex3f(0, carte.map[y][x], 1);
				glColor3f(0, 0, 1);		glVertex3f(1, carte.map[y][x], 1);
				glColor3f(0, 1, 0);		glVertex3f(1, carte.map[y][x], 0);
				glColor3f(1, 1, 1);		glVertex3f(0, carte.map[y][x], 0);
				
				if(carte.map[y][x])
				{
					glColor3f(1, 0, 0);		glVertex3f(0, carte.map[y][x], 0);
					glColor3f(0, 0, 1);		glVertex3f(1, carte.map[y][x], 0);
					glColor3f(0, 1, 0);		glVertex3f(1, 0, 0);
					glColor3f(1, 1, 1);		glVertex3f(0, 0, 0);
					
					glColor3f(1, 0, 0);		glVertex3f(0, carte.map[y][x],1);
					glColor3f(0, 0, 1);		glVertex3f(0, carte.map[y][x], 0);
					glColor3f(0, 1, 0);		glVertex3f(0, 0, 0);
					glColor3f(1, 1, 1);		glVertex3f(0, 0, 1);
					
					glColor3f(1, 0, 0);		glVertex3f(1, carte.map[y][x], 1);
					glColor3f(0, 0, 1);		glVertex3f(0, carte.map[y][x], 1);
					glColor3f(0, 1, 0);		glVertex3f(0, 0, 1);
					glColor3f(1, 1, 1);		glVertex3f(1, 0, 1);
					
					glColor3f(1, 0, 0);		glVertex3f(1, carte.map[y][x], 0);
					glColor3f(0, 0, 1);		glVertex3f(1, carte.map[y][x], 1);
					glColor3f(0, 1, 0);		glVertex3f(1, 0, 1);
					glColor3f(1, 1, 1);		glVertex3f(1, 0, 0);
				}
			glEnd();
			
			glTranslatef(1, 0, 0);
		}
			
		for(u8 i = carte.sX / 7; i > 0; i--)
			glTranslatef(-7, 0, 0);
		
		glTranslatef(-(carte.sX % 7), 0, 1);
	}


return TRUE;
}


void LoadWorld()
{
	carte.sX = 20;
	carte.sY = 20;
	
	carte.map[0][0] = 2;
	carte.map[0][1] = 2;
	carte.map[0][2] = 0;
	carte.map[0][3] = 0;
	carte.map[0][4] = 2;
	carte.map[0][5] = 2;
	carte.map[0][6] = 0;
	carte.map[0][7] = 0;
	carte.map[0][8] = 2;
	carte.map[0][9] = 2;
	carte.map[0][10] = 0;
	carte.map[0][11] = 0;
	carte.map[0][12] = 2;
	carte.map[0][13] = 2;
	carte.map[0][14] = 0;
	carte.map[0][15] = 0;
	carte.map[0][16] = 2;
	carte.map[0][17] = 2;
	carte.map[0][18] = 0;
	carte.map[0][19] = 0;
	
	carte.map[1][0] = 2;
	carte.map[1][1] = 2;
	carte.map[1][2] = 0;
	carte.map[1][3] = 0;
	carte.map[1][4] = 2;
	carte.map[1][5] = 2;
	carte.map[1][6] = 0;
	carte.map[1][7] = 0;
	carte.map[1][8] = 2;
	carte.map[1][9] = 2;
	carte.map[1][10] = 0;
	carte.map[1][11] = 0;
	carte.map[1][12] = 2;
	carte.map[1][13] = 2;
	carte.map[1][14] = 0;
	carte.map[1][15] = 0;
	carte.map[1][16] = 2;
	carte.map[1][17] = 2;
	carte.map[1][18] = 0;
	carte.map[1][19] = 0;
	
	carte.map[2][0] = 0;
	carte.map[2][1] = 0;
	carte.map[2][2] = 2;
	carte.map[2][3] = 2;
	carte.map[2][4] = 0;
	carte.map[2][5] = 0;
	carte.map[2][6] = 2;
	carte.map[2][7] = 2;
	carte.map[2][8] = 0;
	carte.map[2][9] = 0;
	carte.map[2][10] = 2;
	carte.map[2][11] = 2;
	carte.map[2][12] = 0;
	carte.map[2][13] = 0;
	carte.map[2][14] = 2;
	carte.map[2][15] = 2;
	carte.map[2][16] = 0;
	carte.map[2][17] = 0;
	carte.map[2][18] = 2;
	carte.map[2][19] = 2;
	
	carte.map[3][0] = 0;
	carte.map[3][1] = 0;
	carte.map[3][2] = 2;
	carte.map[3][3] = 2;
	carte.map[3][4] = 0;
	carte.map[3][5] = 0;
	carte.map[3][6] = 2;
	carte.map[3][7] = 2;
	carte.map[3][8] = 0;
	carte.map[3][9] = 0;
	carte.map[3][10] = 2;
	carte.map[3][11] = 2;
	carte.map[3][12] = 0;
	carte.map[3][13] = 0;
	carte.map[3][14] = 2;
	carte.map[3][15] = 2;
	carte.map[3][16] = 0;
	carte.map[3][17] = 0;
	carte.map[3][18] = 2;
	carte.map[3][19] = 2;
	
	carte.map[4][0] = 2;
	carte.map[4][1] = 2;
	carte.map[4][2] = 0;
	carte.map[4][3] = 0;
	carte.map[4][4] = 2;
	carte.map[4][5] = 2;
	carte.map[4][6] = 0;
	carte.map[4][7] = 0;
	carte.map[4][8] = 2;
	carte.map[4][9] = 2;
	carte.map[4][10] = 0;
	carte.map[4][11] = 0;
	carte.map[4][12] = 2;
	carte.map[4][13] = 2;
	carte.map[4][14] = 0;
	carte.map[4][15] = 0;
	carte.map[4][16] = 2;
	carte.map[4][17] = 2;
	carte.map[4][18] = 0;
	carte.map[4][19] = 0;
	
	carte.map[5][0] = 2;
	carte.map[5][1] = 2;
	carte.map[5][2] = 0;
	carte.map[5][3] = 0;
	carte.map[5][4] = 2;
	carte.map[5][5] = 2;
	carte.map[5][6] = 0;
	carte.map[5][7] = 0;
	carte.map[5][8] = 2;
	carte.map[5][9] = 2;
	carte.map[5][10] = 0;
	carte.map[5][11] = 0;
	carte.map[5][12] = 2;
	carte.map[5][13] = 2;
	carte.map[5][14] = 0;
	carte.map[5][15] = 0;
	carte.map[5][16] = 2;
	carte.map[5][17] = 2;
	carte.map[5][18] = 0;
	carte.map[5][19] = 0;
	
	carte.map[6][0] = 0;
	carte.map[6][1] = 0;
	carte.map[6][2] = 2;
	carte.map[6][3] = 2;
	carte.map[6][4] = 0;
	carte.map[6][5] = 0;
	carte.map[6][6] = 2;
	carte.map[6][7] = 2;
	carte.map[6][8] = 0;
	carte.map[6][9] = 0;
	carte.map[6][10] = 2;
	carte.map[6][11] = 2;
	carte.map[6][12] = 0;
	carte.map[6][13] = 0;
	carte.map[6][14] = 2;
	carte.map[6][15] = 2;
	carte.map[6][16] = 0;
	carte.map[6][17] = 0;
	carte.map[6][18] = 2;
	carte.map[6][19] = 2;
	
	carte.map[7][0] = 0;
	carte.map[7][1] = 0;
	carte.map[7][2] = 2;
	carte.map[7][3] = 2;
	carte.map[7][4] = 0;
	carte.map[7][5] = 0;
	carte.map[7][6] = 2;
	carte.map[7][7] = 2;
	carte.map[7][8] = 0;
	carte.map[7][9] = 0;
	carte.map[7][10] = 2;
	carte.map[7][11] = 2;
	carte.map[7][12] = 0;
	carte.map[7][13] = 0;
	carte.map[7][14] = 2;
	carte.map[7][15] = 2;
	carte.map[7][16] = 0;
	carte.map[7][17] = 0;
	carte.map[7][18] = 2;
	carte.map[7][19] = 2;
	
	carte.map[8][0] = 2;
	carte.map[8][1] = 2;
	carte.map[8][2] = 0;
	carte.map[8][3] = 0;
	carte.map[8][4] = 2;
	carte.map[8][5] = 2;
	carte.map[8][6] = 0;
	carte.map[8][7] = 0;
	carte.map[8][8] = 2;
	carte.map[8][9] = 2;
	carte.map[8][10] = 0;
	carte.map[8][11] = 0;
	carte.map[8][12] = 2;
	carte.map[8][13] = 2;
	carte.map[8][14] = 0;
	carte.map[8][15] = 0;
	carte.map[8][16] = 2;
	carte.map[8][17] = 2;
	carte.map[8][18] = 0;
	carte.map[8][19] = 0;
	
	carte.map[9][0] = 2;
	carte.map[9][1] = 2;
	carte.map[9][2] = 0;
	carte.map[9][3] = 0;
	carte.map[9][4] = 2;
	carte.map[9][5] = 2;
	carte.map[9][6] = 0;
	carte.map[9][7] = 0;
	carte.map[9][8] = 2;
	carte.map[9][9] = 2;
	carte.map[9][10] = 0;
	carte.map[9][11] = 0;
	carte.map[9][12] = 2;
	carte.map[9][13] = 2;
	carte.map[9][14] = 0;
	carte.map[9][15] = 0;
	carte.map[9][16] = 2;
	carte.map[9][17] = 2;
	carte.map[9][18] = 0;
	carte.map[9][19] = 0;
	
	carte.map[10][0] = 0;
	carte.map[10][1] = 0;
	carte.map[10][2] = 2;
	carte.map[10][3] = 2;
	carte.map[10][4] = 0;
	carte.map[10][5] = 0;
	carte.map[10][6] = 2;
	carte.map[10][7] = 2;
	carte.map[10][8] = 0;
	carte.map[10][9] = 0;
	carte.map[10][10] = 2;
	carte.map[10][11] = 2;
	carte.map[10][12] = 0;
	carte.map[10][13] = 0;
	carte.map[10][14] = 2;
	carte.map[10][15] = 2;
	carte.map[10][16] = 0;
	carte.map[10][17] = 0;
	carte.map[10][18] = 2;
	carte.map[10][19] = 2;
	
	carte.map[11][0] = 0;
	carte.map[11][1] = 0;
	carte.map[11][2] = 2;
	carte.map[11][3] = 2;
	carte.map[11][4] = 0;
	carte.map[11][5] = 0;
	carte.map[11][6] = 2;
	carte.map[11][7] = 2;
	carte.map[11][8] = 0;
	carte.map[11][9] = 0;
	carte.map[11][10] = 2;
	carte.map[11][11] = 2;
	carte.map[11][12] = 0;
	carte.map[11][13] = 0;
	carte.map[11][14] = 2;
	carte.map[11][15] = 2;
	carte.map[11][16] = 0;
	carte.map[11][17] = 0;
	carte.map[11][18] = 2;
	carte.map[11][19] = 2;
	
	carte.map[12][0] = 2;
	carte.map[12][1] = 2;
	carte.map[12][2] = 0;
	carte.map[12][3] = 0;
	carte.map[12][4] = 2;
	carte.map[12][5] = 2;
	carte.map[12][6] = 0;
	carte.map[12][7] = 0;
	carte.map[12][8] = 2;
	carte.map[12][9] = 2;
	carte.map[12][10] = 0;
	carte.map[12][11] = 0;
	carte.map[12][12] = 2;
	carte.map[12][13] = 2;
	carte.map[12][14] = 0;
	carte.map[12][15] = 0;
	carte.map[12][16] = 2;
	carte.map[12][17] = 2;
	carte.map[12][18] = 0;
	carte.map[12][19] = 0;
	
	carte.map[13][0] = 2;
	carte.map[13][1] = 2;
	carte.map[13][2] = 0;
	carte.map[13][3] = 0;
	carte.map[13][4] = 2;
	carte.map[13][5] = 2;
	carte.map[13][6] = 0;
	carte.map[13][7] = 0;
	carte.map[13][8] = 2;
	carte.map[13][9] = 2;
	carte.map[13][10] = 0;
	carte.map[13][11] = 0;
	carte.map[13][12] = 2;
	carte.map[13][13] = 2;
	carte.map[13][14] = 0;
	carte.map[13][15] = 0;
	carte.map[13][16] = 2;
	carte.map[13][17] = 2;
	carte.map[13][18] = 0;
	carte.map[13][19] = 0;
	
	carte.map[14][0] = 0;
	carte.map[14][1] = 0;
	carte.map[14][2] = 2;
	carte.map[14][3] = 2;
	carte.map[14][4] = 0;
	carte.map[14][5] = 0;
	carte.map[14][6] = 2;
	carte.map[14][7] = 2;
	carte.map[14][8] = 0;
	carte.map[14][9] = 0;
	carte.map[14][10] = 2;
	carte.map[14][11] = 2;
	carte.map[14][12] = 0;
	carte.map[14][13] = 0;
	carte.map[14][14] = 2;
	carte.map[14][15] = 2;
	carte.map[14][16] = 0;
	carte.map[14][17] = 0;
	carte.map[14][18] = 2;
	carte.map[14][19] = 2;
	
	carte.map[15][0] = 0;
	carte.map[15][1] = 0;
	carte.map[15][2] = 2;
	carte.map[15][3] = 2;
	carte.map[15][4] = 0;
	carte.map[15][5] = 0;
	carte.map[15][6] = 2;
	carte.map[15][7] = 2;
	carte.map[15][8] = 0;
	carte.map[15][9] = 0;
	carte.map[15][10] = 2;
	carte.map[15][11] = 2;
	carte.map[15][12] = 0;
	carte.map[15][13] = 0;
	carte.map[15][14] = 2;
	carte.map[15][15] = 2;
	carte.map[15][16] = 0;
	carte.map[15][17] = 0;
	carte.map[15][18] = 2;
	carte.map[15][19] = 2;
	
	carte.map[16][0] = 2;
	carte.map[16][1] = 2;
	carte.map[16][2] = 0;
	carte.map[16][3] = 0;
	carte.map[16][4] = 2;
	carte.map[16][5] = 2;
	carte.map[16][6] = 0;
	carte.map[16][7] = 0;
	carte.map[16][8] = 2;
	carte.map[16][9] = 2;
	carte.map[16][10] = 0;
	carte.map[16][11] = 0;
	carte.map[16][12] = 2;
	carte.map[16][13] = 2;
	carte.map[16][14] = 0;
	carte.map[16][15] = 0;
	carte.map[16][16] = 2;
	carte.map[16][17] = 2;
	carte.map[16][18] = 0;
	carte.map[16][19] = 0;
	
	carte.map[17][0] = 2;
	carte.map[17][1] = 2;
	carte.map[17][2] = 0;
	carte.map[17][3] = 0;
	carte.map[17][4] = 2;
	carte.map[17][5] = 2;
	carte.map[17][6] = 0;
	carte.map[17][7] = 0;
	carte.map[17][8] = 2;
	carte.map[17][9] = 2;
	carte.map[17][10] = 0;
	carte.map[17][11] = 0;
	carte.map[17][12] = 2;
	carte.map[17][13] = 2;
	carte.map[17][14] = 0;
	carte.map[17][15] = 0;
	carte.map[17][16] = 2;
	carte.map[17][17] = 2;
	carte.map[17][18] = 0;
	carte.map[17][19] = 0;
	
	carte.map[18][0] = 0;
	carte.map[18][1] = 0;
	carte.map[18][2] = 2;
	carte.map[18][3] = 2;
	carte.map[18][4] = 0;
	carte.map[18][5] = 0;
	carte.map[18][6] = 2;
	carte.map[18][7] = 2;
	carte.map[18][8] = 0;
	carte.map[18][9] = 0;
	carte.map[18][10] = 2;
	carte.map[18][11] = 2;
	carte.map[18][12] = 0;
	carte.map[18][13] = 0;
	carte.map[18][14] = 2;
	carte.map[18][15] = 2;
	carte.map[18][16] = 0;
	carte.map[18][17] = 0;
	carte.map[18][18] = 2;
	carte.map[18][19] = 2;
	
	carte.map[19][0] = 0;
	carte.map[19][1] = 0;
	carte.map[19][2] = 2;
	carte.map[19][3] = 2;
	carte.map[19][4] = 0;
	carte.map[19][5] = 0;
	carte.map[19][6] = 2;
	carte.map[19][7] = 2;
	carte.map[19][8] = 0;
	carte.map[19][9] = 0;
	carte.map[19][10] = 2;
	carte.map[19][11] = 2;
	carte.map[19][12] = 0;
	carte.map[19][13] = 0;
	carte.map[19][14] = 2;
	carte.map[19][15] = 2;
	carte.map[19][16] = 0;
	carte.map[19][17] = 0;
	carte.map[19][18] = 2;
	carte.map[19][19] = 2;
}

